//Myriad Memories - Lua script:

local downlit = false
local leftlit = false
local rightlit = false
local uplit = false

local yellowbutton = false
local redbutton = false
local greenbutton = false

//Pulley!

//for freeslot:

freeslot("sfx_pull")

freeslot("MT_PULLEY", "MT_PULLEYBASE", "MT_PULLEYPOINT")
freeslot("S_PULLEY", "S_PULLEYBASE", "S_PULLEYPOINT")
freeslot("SPR_PULL")

//...

freeslot("MT_BLUESPRINGBALL")
freeslot("S_BLUESPRINGBALL", "S_BLUESPRINGBALL2", "S_BLUESPRINGBALL3", "S_BLUESPRINGBALL4", "S_BLUESPRINGBALL5")
freeslot("SPR_BSPB")

//Caption:

sfxinfo[sfx_pull].caption = "Pulley"

//--------

mobjinfo[MT_PULLEY] = {
    doomednum = 2800,
    //$Sprite PULLA0
	//$Name Pulley
	spawnstate = S_PULLEY,
	height = 25*FRACUNIT,
	radius = 22*FRACUNIT,
	dispoffset = -1,
	//flags = MF_SOLID|MF_FLOAT|MF_NOGRAVITY|MF_STICKY
	flags = MF_FLOAT|MF_NOGRAVITY|MF_STICKY
}

states[S_PULLEY] = {SPR_PULL, A, 1, nil, 0, 0, S_PULLEY}

//Now the base!

mobjinfo[MT_PULLEYBASE] = {
    doomednum = 2801,
    //$Sprite PULLB0
	//$Name Pulley Base
	spawnstate = S_PULLEYBASE,
	height = 14*FRACUNIT,
	radius = 25*FRACUNIT,
	flags = MF_SOLID|MF_FLOAT|MF_NOGRAVITY|MF_STICKY
}

states[S_PULLEYBASE] = {SPR_PULL, B, 1, nil, 0, 0, S_PULLEYBASE}

mobjinfo[MT_PULLEYPOINT] = {
    doomednum = 2134,
    //$Sprite PULLB0
	//$Name Pulley Point
	spawnstate = S_PULLEYPOINT,
	seestate = S_PULLEYPOINT,
	meleestate = S_PULLEYPOINT,
	missilestate = S_PULLEYPOINT,
	painstate = S_PULLEYPOINT,
	deathstate = S_PULLEYPOINT,
	xdeathstate = S_PULLEYPOINT,
	height = 14*FRACUNIT,
	radius = 25*FRACUNIT,
	flags = MF_FLOAT|MF_NOGRAVITY
}

states[S_PULLEYPOINT] = {SPR_NULL, A, 1, nil, 0, 0, S_PULLEYPOINT}

//...

mobjinfo[MT_BLUESPRINGBALL] = {
    doomednum = 2135,
    //$Sprite BSPBA0
	//$Name Blue Spring Ball
	spawnstate = S_BLUESPRINGBALL,
	seestate = S_BLUESPRINGBALL2,
	painsound = sfx_spring,
	deathsound = sfx_pop,
	activesound = sfx_mswing,
	raisestate = S_BLUESPRINGBALL2,
	spawnhealth = 1000,
	speed = 24*FRACUNIT,
	radius = 17*FRACUNIT,
	height = 34*FRACUNIT,
	dispoffset = 1,
	mass = 11*FRACUNIT,
	flags = MF_SCENERY|MF_SPRING|MF_NOGRAVITY
}

states[S_BLUESPRINGBALL] = {SPR_BSPB, A, -1, nil, 0, 0, S_NULL}
states[S_BLUESPRINGBALL2] = {SPR_BSPB, E, 4, A_Pain, 0, 0, S_BLUESPRINGBALL3}
states[S_BLUESPRINGBALL3] = {SPR_BSPB, D, 1, nil, 0, 0, S_BLUESPRINGBALL4}
states[S_BLUESPRINGBALL4] = {SPR_BSPB, C, 1, nil, 0, 0, S_BLUESPRINGBALL5}
states[S_BLUESPRINGBALL5] = {SPR_BSPB, B, 1, nil, 0, 0, S_BLUESPRINGBALL}

local bots = {}
local pulleypoints = {}
local pulleys = {}

addHook("NetVars", function(network)
	bots = network(bots)
	pulleypoints = network(pulleypoints)
	pulleys = network(pulleys)
	yellowbutton = network(yellowbutton)
	redbutton = network(redbutton)
	greenbutton = network(greenbutton)
	uplit = network(uplit)
	leftlit = network(leftlit)
	rightlit = network(rightlit)
	downlit = network(downlit)
end)

local function PuzzleHelp(line, mo)
	if (mapheaderinfo[gamemap].myriadmemories) //Just to make sure-
		COM_BufInsertText(mo.player, "cecho Press the following buttons\\\in the order of the colors' appearance\\\ all the way from the beginning\\\ to this area")
	end
end
addHook("LinedefExecute", PuzzleHelp, "PUZZLEHE")

local function SetPuzzle(line, mo)
	if (mapheaderinfo[gamemap].myriadmemories) //Just to make sure-
		//Setting up colors:
		local walltexture = "YELWALL"
		local floortexture = "YELFLR"
		local randomchoice = ""
		local randomchoice2 = ""
		local randomchoice3 = ""
		local tagfirstpart = 0
		local tagsecondpart = 0
		local tagthirdpart = 0
		local randomcolor = {"yellow", "red", "green"}
		randomchoice = randomcolor[P_RandomKey(#randomcolor)+1]
		
		if (randomchoice == "yellow")
			tagfirstpart = 124
			tagsecondpart = 121
			tagthirdpart = 127
			walltexture = "YELWALL"
			floortexture = "YELFLR"
		elseif (randomchoice == "red")
			tagfirstpart = 125
			tagsecondpart = 122
			tagthirdpart = 128
			walltexture = "REDWALL"
			floortexture = "REDFLR"
		elseif (randomchoice == "green")
			tagfirstpart = 126
			tagsecondpart = 123
			tagthirdpart = 129
			walltexture = "NEOGWALL"
			floortexture = "NEOGFLR"
		end
			
		//Setting up top button:
			
		for sector in sectors.iterate
			if (sector.tag == 212)
				sector.tag = tagfirstpart
				sector.floorpic = floortexture
			end
			if (sector.tag == 213)
				sector.tag = tagsecondpart
				sector.floorpic = floortexture
			end
			if (sector.tag == 214)
				sector.tag = tagthirdpart
				sector.floorpic = floortexture
			end
		end
		
		lines[3267].frontside.bottomtexture = R_TextureNumForName(walltexture)
		lines[3228].frontside.bottomtexture = R_TextureNumForName(walltexture)
		lines[3270].backside.bottomtexture = R_TextureNumForName(walltexture)
		lines[3271].backside.bottomtexture = R_TextureNumForName(walltexture)
		lines[3229].backside.bottomtexture = R_TextureNumForName(walltexture)
		lines[3182].backside.bottomtexture = R_TextureNumForName(walltexture)
		lines[3227].backside.bottomtexture = R_TextureNumForName(walltexture)
		lines[3266].backside.bottomtexture = R_TextureNumForName(walltexture)
		
		randomchoice2 = randomchoice
		
		while (randomchoice2 == randomchoice)
			randomchoice2 = randomcolor[P_RandomKey(#randomcolor)+1]
		end
		
		if (randomchoice2 == "yellow")
			tagfirstpart = 124
			tagsecondpart = 121
			tagthirdpart = 127
			walltexture = "YELWALL"
			floortexture = "YELFLR"
		elseif (randomchoice2 == "red")
			tagfirstpart = 125
			tagsecondpart = 122
			tagthirdpart = 128
			walltexture = "REDWALL"
			floortexture = "REDFLR"
		elseif (randomchoice2 == "green")
			tagfirstpart = 126
			tagsecondpart = 123
			tagthirdpart = 129
			walltexture = "NEOGWALL"
			floortexture = "NEOGFLR"
		end
		
		//Setting up middle button:
		
		for sector in sectors.iterate
			if (sector.tag == 215)
				sector.tag = tagfirstpart
				sector.floorpic = floortexture
			end
			if (sector.tag == 216)
				sector.tag = tagsecondpart
				sector.floorpic = floortexture
			end
			if (sector.tag == 217)
				sector.tag = tagthirdpart
				sector.floorpic = floortexture
			end
		end
		
		lines[3261].backside.bottomtexture = R_TextureNumForName(walltexture)
		lines[3181].backside.bottomtexture = R_TextureNumForName(walltexture)
		lines[3264].backside.bottomtexture = R_TextureNumForName(walltexture)
		lines[3265].backside.bottomtexture = R_TextureNumForName(walltexture)
		lines[3232].backside.bottomtexture = R_TextureNumForName(walltexture)
		lines[3235].backside.bottomtexture = R_TextureNumForName(walltexture)
		lines[3230].backside.bottomtexture = R_TextureNumForName(walltexture)
		lines[3260].backside.bottomtexture = R_TextureNumForName(walltexture)
		
		randomchoice3 = randomchoice
		
		while ((randomchoice3 == randomchoice) or (randomchoice3 == randomchoice2))
			randomchoice3 = randomcolor[P_RandomKey(#randomcolor)+1]
		end
		
		if (randomchoice3 == "yellow")
			tagfirstpart = 124
			tagsecondpart = 121
			tagthirdpart = 127
			walltexture = "YELWALL"
			floortexture = "YELFLR"
		elseif (randomchoice3 == "red")
			tagfirstpart = 125
			tagsecondpart = 122
			tagthirdpart = 128
			walltexture = "REDWALL"
			floortexture = "REDFLR"
		elseif (randomchoice3 == "green")
			tagfirstpart = 126
			tagsecondpart = 123
			tagthirdpart = 129
			walltexture = "NEOGWALL"
			floortexture = "NEOGFLR"
		end
			
		//Setting up bottom button:
		
		for sector in sectors.iterate
			if (sector.tag == 218)
				sector.tag = tagfirstpart
				sector.floorpic = floortexture
			end
			if (sector.tag == 219)
				sector.tag = tagsecondpart
				sector.floorpic = floortexture
			end
			if (sector.tag == 220)
				sector.tag = tagthirdpart
				sector.floorpic = floortexture
			end
		end
		
		lines[3276].backside.bottomtexture = R_TextureNumForName(walltexture)
		lines[3234].backside.bottomtexture = R_TextureNumForName(walltexture)
		lines[3273].backside.bottomtexture = R_TextureNumForName(walltexture)
		lines[3274].backside.bottomtexture = R_TextureNumForName(walltexture)
		lines[3238].backside.bottomtexture = R_TextureNumForName(walltexture)
		lines[3239].backside.bottomtexture = R_TextureNumForName(walltexture)
		lines[3236].backside.bottomtexture = R_TextureNumForName(walltexture)
		lines[3275].backside.bottomtexture = R_TextureNumForName(walltexture)
	end
end
addHook("LinedefExecute", SetPuzzle, "SETPUZZL")

local function SpawnGargoyleOne(line, mo)
	if (mapheaderinfo[gamemap].myriadmemories) //Just to make sure-
		P_SpawnMobj(576*FRACUNIT, 1888*FRACUNIT, 200*FRACUNIT, MT_GARGOYLE)
	end
end
addHook("LinedefExecute", SpawnGargoyleOne, "SPGRONE")

local function SpawnGargoyleTwo(line, mo)
	if (mapheaderinfo[gamemap].myriadmemories) //Just to make sure-
		P_SpawnMobj(640*FRACUNIT, 1888*FRACUNIT, 200*FRACUNIT, MT_GARGOYLE)
	end
end
addHook("LinedefExecute", SpawnGargoyleTwo, "SPGRTWO")

local function SpawnGargoyleThree(line, mo)
	if (mapheaderinfo[gamemap].myriadmemories) //Just to make sure-
		P_SpawnMobj(704*FRACUNIT, 1888*FRACUNIT, 200*FRACUNIT, MT_GARGOYLE)
	end
end
addHook("LinedefExecute", SpawnGargoyleThree, "SPGRTHR")

local function YellowButtonPress(line, mo)
	if (mapheaderinfo[gamemap].myriadmemories) //Just to make sure-
		if (mo.subsector.sector.floorheight == 716*FRACUNIT)
			if (redbutton == true)
			and (yellowbutton == false)
			and (greenbutton == false)
				P_LinedefExecute(905)
				yellowbutton = true
			end
			if (redbutton == true)
			and (yellowbutton == false)
			and (greenbutton == true)
				P_LinedefExecute(905)
				yellowbutton = true
			end
			if (redbutton == false)
			and (yellowbutton == false)
			and (greenbutton == false)
				P_DamageMobj(mo)
			end
			if (redbutton == false)
			and (yellowbutton == false)
			and (greenbutton == true)
				P_DamageMobj(mo)
			end
		end
	end
end
addHook("LinedefExecute", YellowButtonPress, "YELBUTTO")

local function RedButtonPress(line, mo)
	if (mapheaderinfo[gamemap].myriadmemories) //Just to make sure-
		if (mo.subsector.sector.floorheight == 716*FRACUNIT)
			if (redbutton == false)
			and (yellowbutton == false)
			and (greenbutton == false)
				P_LinedefExecute(906)
				redbutton = true
			end
			if (redbutton == false)
			and (yellowbutton == true)
			and (greenbutton == true)
				P_LinedefExecute(906)
				redbutton = true
			end
			if (redbutton == false)
			and (yellowbutton == false)
			and (greenbutton == true)
				P_LinedefExecute(906)
				redbutton = true
			end
			if (redbutton == false)
			and (yellowbutton == true)
			and (greenbutton == false)
				P_LinedefExecute(906)
				redbutton = true
			end
		end
	end
end
addHook("LinedefExecute", RedButtonPress, "REDBUTTO")

local function GreenButtonPress(line, mo)
	if (mapheaderinfo[gamemap].myriadmemories) //Just to make sure-
		if (mo.subsector.sector.floorheight == 716*FRACUNIT)
			if (redbutton == false)
			and (yellowbutton == false)
			and (greenbutton == false)
				P_DamageMobj(mo)
			end
			if (redbutton == true)
			and (yellowbutton == false)
			and (greenbutton == false)
				P_DamageMobj(mo)
			end
			if (redbutton == false)
			and (yellowbutton == true)
			and (greenbutton == false)
				P_DamageMobj(mo)
			end
			if (redbutton == true)
			and (yellowbutton == true)
			and (greenbutton == false)
				P_LinedefExecute(907)
				greenbutton = true
			end
		end
	end
end
addHook("LinedefExecute", GreenButtonPress, "GRNBUTTO")

local function DownLitOn(line, mo)
	if (mapheaderinfo[gamemap].myriadmemories) //Just to make sure-
		//if ((netgame == false) and (multiplayer == false)) //Only in Singleplayer.
		if (downlit == false)
			if (rightlit == true)
			and (uplit == true)
			and (leftlit == true)
				P_LinedefExecute(910) //final teleporter.
			end
			downlit = true //Remember that you lit the southern green light.
		end
		//end
	end
end
addHook("LinedefExecute", DownLitOn, "DOWNLIT")

local function LeftLitOn(line, mo)
	if (mapheaderinfo[gamemap].myriadmemories) //Just to make sure-
		//if ((netgame == false) and (multiplayer == false)) //Only in Singleplayer.
		if (leftlit == false)
			if (rightlit == true)
			and (uplit == true)
			and (downlit == true)
				P_LinedefExecute(910) //final teleporter.
			end
			leftlit = true //Remember that you lit the eastern green light.
		end
		//end
	end
end
addHook("LinedefExecute", LeftLitOn, "LEFTLIT")

local function RightLitOn(line, mo)
	if (mapheaderinfo[gamemap].myriadmemories) //Just to make sure-
		//if ((netgame == false) and (multiplayer == false)) //Only in Singleplayer.
		if (rightlit == false)
			if (leftlit == true)
			and (uplit == true)
			and (downlit == true)
				P_LinedefExecute(910) //final teleporter.
			end
			rightlit = true //Remember that you lit the western green light.
		end
		//end
	end
end
addHook("LinedefExecute", RightLitOn, "RIGHTLIT")

local function UpLitOn(line, mo)
	if (mapheaderinfo[gamemap].myriadmemories) //Just to make sure-
		//if ((netgame == false) and (multiplayer == false)) //Only in Singleplayer.
		if (uplit == false)
			if (leftlit == true)
			and (rightlit == true)
			and (downlit == true)
				P_LinedefExecute(910) //final teleporter.
			end
			uplit = true //Remember that you lit the northern green light.
		end
		//end
	end
end
addHook("LinedefExecute", UpLitOn, "UPLIT")

addHook("MapLoad", do
	if (mapheaderinfo[gamemap].myriadmemories)
		for mobj in mobjs.iterate()
			if (mobj.type == MT_PLAYER)
			and (mobj.player)
			and (mobj.player.bot == 1)
				table.insert(bots,mobj)
			end
		end
		for point in mobjs.iterate()
			if (point.type == MT_PULLEYPOINT)
				table.insert(pulleypoints,point)
			end
		end
		for pulley in mobjs.iterate()
			if (pulley.type == MT_PULLEY)
				table.insert(pulleys,pulley)
			end
		end
		yellowbutton = false
		redbutton = false
		greenbutton = false
		//print("DISABLE EVERYTHING")
		if ((netgame == false) and (multiplayer == false)) //Only in Singleplayer.
			if (players[0].starposttime) //Player has touched a checkpoint?
				if (downlit == true) //You lit the southern green light?
					P_LinedefExecute(97) //lit it.
				end
				if (leftlit == true) //You lit the eastern green light?
					P_LinedefExecute(245) //lit it.
				end
				if (rightlit == true) //You lit the western green light?
					P_LinedefExecute(176) //lit it.
				end
				if (uplit == true) //You lit the northern green light?
					P_LinedefExecute(210) //lit it.
				end
				if (uplit == true) //You lit the northern green light?
				and (downlit == true) //You lit the southern green light?
				and (leftlit == true) //You lit the eastern green light?
				and (rightlit == true) //You lit the western green light?
					P_LinedefExecute(910) //final teleporter.
				end
			else //Player hasn't touched a checkpoint?
				downlit = false
				leftlit = false
				rightlit = false //Forget about these then!
				uplit = false
			end
		else
			downlit = false
			leftlit = false
			rightlit = false //Forget about these then!
			uplit = false
		end
	else  //You load a different map?
		downlit = false
		leftlit = false
		rightlit = false //Forget about these then!
		uplit = false
	end
end)

//addHook("JumpSpecial", function(player)
//	if (player.hang == true)
//		return true
//	end
//end)

addHook("ThinkFrame", function()
	if not (mapheaderinfo[gamemap].myriadmemories) return end
	
	//if (redbutton == true)
	//and (yellowbutton == true)
	//and (leveltime >= TICRATE)
	//	P_LinedefExecute(139) //Red Button and Yellow Button pushed tag!
	//	//print("GREEN IS HARMLESS NOW")
	//end
	
	for player in players.iterate
		if (player.hang == nil)
			player.hang = false
		end
		if (player.dietimer == nil)
			player.dietimer = 0
		end
		if (player.playerstate == PST_DEAD)
			player.dietimer = $1 + 1
		else
			player.dietimer = 0
		end
		if (player.jumpbuttonnn == nil)
			player.jumpbuttonnn = 0
		end
		if (player.goingondelay == nil)
			player.goingondelay = 0
		end
		if (player.goingondelay > 0)
			player.goingondelay = $1 - 1
		end
		if (player.catch == nil)
			player.catch = false
		end
		
		--if (player.mo and player.mo.valid)
		--	if (P_IsObjectOnGround(player.mo))
		--		if (redbutton == false)
		--		and (yellowbutton == false)
		--		and (greenbutton == false)
		--			if (player.mo.subsector.sector.floorheight == 716*FRACUNIT)
		--				if ((player.mo.subsector.sector.floorpic == "YELFLR") or (player.mo.subsector.sector.floorpic == "NEOGFLR"))
		--					P_DamageMobj(player.mo)
		--				end
		--			end
		--		end
		--		if (redbutton == true)
		--		and (yellowbutton == false)
		--		and (greenbutton == false)
		--			if (player.mo.subsector.sector.floorheight == 716*FRACUNIT)
		--				if (player.mo.subsector.sector.floorpic == "NEOGFLR")
		--					P_DamageMobj(player.mo)
		--				end
		--			end
		--		end
		--		if (redbutton == false)
		--		and (yellowbutton == true)
		--		and (greenbutton == false)
		--			if (player.mo.subsector.sector.floorheight == 716*FRACUNIT)
		--				if (player.mo.subsector.sector.floorpic == "NEOGFLR")
		--					P_DamageMobj(player.mo)
		--				end
		--			end
		--		end
		--		if (redbutton == false)
		--		and (yellowbutton == false)
		--		and (greenbutton == true)
		--			if (player.mo.subsector.sector.floorheight == 716*FRACUNIT)
		--				if (player.mo.subsector.sector.floorpic == "YELFLR")
		--					P_DamageMobj(player.mo)
		--				end
		--			end
		--		end
		--	end
		--end
		
		
		if (player.hang == true)
			if (player.mo and player.mo.valid)
				player.mo.momz = 0
			end
		end
		if (player.cmd.buttons & BT_JUMP)
			player.jumpbuttonnn = $1 + 1
		else
			player.jumpbuttonnn = 0
		end
		if (player.playerstate == PST_DEAD)
			player.hang = false
			player.catch = false
			player.goingondelay = 0
			player.jumpbuttonnn = 0
		end
		
		if (player.mo and player.mo.valid)
		and (player.hang == true)
		and (player.hangobject and player.hangobject.valid)
			player.pflags = ($1|PF_THOKKED)
			//player.secondjump = 2
			//player.jumping = true
			player.drawangle = player.mo.angle
			player.mo.state = S_PLAY_RIDE
			//player.powers[pw_carry] = CR_PLAYER
			//player.mo.sprite = skins[player.mo.skin].sprites[SPR_RIDE]
			//player.mo.frame = A
			P_TeleportMove(player.mo,player.hangobject.x,player.hangobject.y,player.hangobject.z-42*FRACUNIT)
			player.mo.momx = 0
			player.mo.momy = 0
			player.powers[pw_nocontrol] = 1
			player.goingondelay = 20
			//player.pflags = ($1 &~ PF_JUMPSTASIS)
			//player.jumpendover = 10
		end
	   
		for i = 1, #bots
			if (bots[i] and bots[i].valid)
			and (player.mo and player.mo.valid)
			and (player.hang == true)
			and (player.hangobject and player.hangobject.valid)
			and (bots[i].player.playerstate == PST_LIVE)
			and (bots[i].player.catch == false)
			and not (bots[i].state == S_PLAY_PAIN)
			and not (bots[i].state == S_PLAY_DEAD)
			and bots[i].player.hangobjectrecent ~= player.hangobject
				P_TeleportMove(bots[i],player.mo.x,player.mo.y,player.mo.z)
				bots[i].player.catch = true
				bots[i].player.hang = true
				bots[i].player.hangobject = player.hangobject
				bots[i].player.hangobjectrecent = player.hangobject
				bots[i].player.hangobject.playercount = $1 + 1
				table.insert(bots[i].player.hangobject.playerstable, bots[i].player)
			end
		end
	   
	    if (player.mo and player.mo.valid)
		and (player.hang == true)
		and (player.catch == true)
		and (player.jumpbuttonnn == 1)
		and (player.bot ~= 1)
			//P_TeleportMove(player.mo,player.hangobject.x+FixedMul(40*FRACUNIT, cos(player.mo.angle)),player.hangobject.y+FixedMul(40*FRACUNIT, cos(player.mo.angle)),player.mo.z)
			player.hangobject.playercount = $1 - 1
			table.remove(player.hangobject.playerstable)
			player.mo.state = S_PLAY_JUMP
			player.mo.sprite2 = SPR2_ROLL
			player.mo.sprite = SPR_PLAY
			if not ((skins[player.mo.skin].flags & SF_NOJUMPSPIN) and (skins[player.mo.skin].flags & SF_NOJUMPDAMAGE))
				player.pflags = ($1|PF_JUMPED)
			else
				player.pflags = ($1 &~ PF_JUMPED)
			end
			local thrust = 19*FRACUNIT
			if (player.hangobject.spawnpoint.options & MTF_EXTRA)
			and (player.hangobject.metal)
				thrust = player.hangobject.metal.master.frontside.textureoffset
			end
			P_Thrust(player.mo,player.mo.angle,thrust)
			player.hang = false
			player.catch = false
			player.goingondelay = 20
			player.mo.momz = 0
			player.hangobject = nil
			//player.secondjump = 2
			//player.jumping = true
		end
	   
		for i = 1, #bots
			if (bots[i] and bots[i].valid)
			and (bots[i].player.hang == true)
			and (bots[i].player.catch == true)
			and (player.mo and player.mo.valid)
			and (player.bot ~= 1)
			and (player.hang == false)
				bots[i].player.hangobject.playercount = $1 - 1
				table.remove(bots[i].player.hangobject.playerstable)
				player.mo.state = S_PLAY_JUMP
				bots[i].state = S_PLAY_JUMP
				P_Thrust(bots[i],player.mo.angle,19*FRACUNIT)
				bots[i].angle = player.mo.angle
				bots[i].player.hang = false
				bots[i].player.catch = false
				bots[i].player.goingondelay = 20
				bots[i].momz = 0
				bots[i].player.hangobject = nil
			end
		end
		
		if (player.mo and player.mo.valid)
		and (player.hangobject and player.hangobject.valid)
		and (player.hangobject.gotoangle == true)
		and (player.hangobject.spawnpoint.options & MTF_OBJECTSPECIAL)
		and ((player.hangobject.z+player.hangobject.height>=(player.hangobject.spawnpoint.angle*FRACUNIT-10*FRACUNIT)) and (player.hangobject.z+player.hangobject.height<=player.hangobject.spawnpoint.angle*FRACUNIT+10*FRACUNIT))
			player.hangobject.goback = true
			player.hangobject.gotoangle = false
			player.hangobject.givepushback = true
			player.hangobject.giveanglepush = false
			player.hangobject.gobackdown = true
			player.mo.state = S_PLAY_JUMP
			player.mo.sprite2 = SPR2_ROLL
			player.mo.sprite = SPR_PLAY
			if not ((skins[player.mo.skin].flags & SF_NOJUMPSPIN) and (skins[player.mo.skin].flags & SF_NOJUMPDAMAGE))
				player.pflags = ($1|PF_JUMPED)
			else
				player.pflags = ($1 &~ PF_JUMPED)
			end
			player.hang = false
			player.catch = false
			player.hangobject.playercount = $1 - 1
			table.remove(player.hangobject.playerstable)
			player.goingondelay = 20
			if (player.hangobject.metal)
			and not (player.hangobject.spawnpoint.options & MTF_AMBUSH)
				P_InstaThrust(player.mo,player.mo.angle,player.hangobject.metal.master.frontside.textureoffset)
				player.mo.momz = player.hangobject.metal.master.frontside.rowoffset
			end
			player.hangobject = nil
			//player.secondjump = 2
			//player.jumping = true
		end
		if (player.mo and player.mo.valid)
		and (player.hangobject and player.hangobject.valid)
		and (player.hangobject.gotoangle == true)
		and (player.hangobject.spawnpoint.options & MTF_AMBUSH)
		and (player.hangobject.originalx > player.hangobject.nextpoint.x)
		and (player.hangobject.x <= player.hangobject.nextpoint.x)
			player.mo.state = S_PLAY_JUMP
			player.mo.sprite2 = SPR2_ROLL
			player.mo.sprite = SPR_PLAY
			if not ((skins[player.mo.skin].flags & SF_NOJUMPSPIN) and (skins[player.mo.skin].flags & SF_NOJUMPDAMAGE))
				player.pflags = ($1|PF_JUMPED)
			else
				player.pflags = ($1 &~ PF_JUMPED)
			end
			player.hang = false
			player.catch = false
			player.hangobject.playercount = $1 - 1
			table.remove(player.hangobject.playerstable)
			player.goingondelay = 20
			player.hangobject.goback = true
			player.hangobject.gotoangle = false
			player.hangobject.givepushback = true
			player.hangobject.giveanglepush = false
			player.hangobject.gobackdown = true
			player.mo.momx = player.hangobject.momx
			player.hangobject.momx = 0
			player.hangobject.momy = 0
			player.hangobject.momz = 0
			//P_Thrust(player.mo,player.mo.angle,10*FRACUNIT)
			player.mo.momz = $1 + 3*FRACUNIT
			player.hangobject = nil
			//player.secondjump = 2
			//player.jumping = true
		end
		if (player.mo and player.mo.valid)
		and (player.hangobject and player.hangobject.valid)
		and (player.hangobject.gotoangle == true)
		and (player.hangobject.spawnpoint.options & MTF_AMBUSH)
		and (player.hangobject.originalx < player.hangobject.nextpoint.x)
		and (player.hangobject.x >= player.hangobject.nextpoint.x)
			player.mo.state = S_PLAY_JUMP
			player.mo.sprite2 = SPR2_ROLL
			player.mo.sprite = SPR_PLAY
			if not ((skins[player.mo.skin].flags & SF_NOJUMPSPIN) and (skins[player.mo.skin].flags & SF_NOJUMPDAMAGE))
				player.pflags = ($1|PF_JUMPED)
			else
				player.pflags = ($1 &~ PF_JUMPED)
			end
			player.hang = false
			player.catch = false
			player.hangobject.playercount = $1 - 1
			table.remove(player.hangobject.playerstable)
			player.goingondelay = 20
			player.hangobject.goback = true
			player.hangobject.gotoangle = false
			player.hangobject.givepushback = true
			player.hangobject.giveanglepush = false
			player.hangobject.gobackdown = true
			player.mo.momx = player.hangobject.momx
			player.hangobject.momx = 0
			player.hangobject.momy = 0
			player.hangobject.momz = 0
			//P_Thrust(player.mo,player.mo.angle,10*FRACUNIT)
			player.mo.momz = $1 + 3*FRACUNIT
			player.hangobject = nil
			//player.secondjump = 2
			//player.jumping = true
		end
		if (player.goingondelay == 1)
			player.hangobjectrecent = nil
		end
	end
	
	
	//Pulleys mobjs:
	
	
	if (mapheaderinfo[gamemap].myriadmemories)
		for i = 1, #pulleys
			if (pulleys[i] and pulleys[i].valid)
			
			
				if (pulleys[i].playerstable == nil)
					pulleys[i].playerstable = {}
				end
				
				if (pulleys[i].playerstable ~= nil)
					if (#pulleys[i].playerstable == 0)
						pulleys[i].playercount = 0
					end
				end		
						
				for j = 1, #pulleypoints
					if (pulleypoints[j] and pulleypoints[j].valid)
					and (pulleypoints[j].spawnpoint.angle == pulleys[i].spawnpoint.angle)
					and (pulleys[i].spawnpoint.options & MTF_AMBUSH)
						pulleys[i].nextpoint = pulleypoints[j]
					end
				end
			   
				if not (pulleys[i].spawnpoint.options & MTF_AMBUSH)
					pulleys[i].nextpoint = pulleys[i]
				end
			   
				if (pulleys[i].gotoangle == nil)
					pulleys[i].gotoangle = false
				end
				if (pulleys[i].gobackdown == nil)
					pulleys[i].gobackdown = false
				end
				if (pulleys[i].gobackdowntimer == nil)
					pulleys[i].gobackdowntimer = 0
				end
				if (pulleys[i].goback == nil)
					pulleys[i].goback = false
				end
				if (pulleys[i].givepushback == nil)
					pulleys[i].givepushback = false
				end
				if (pulleys[i].givepushtimer == nil)
					pulleys[i].givepushtimer = 0
				end
				if (pulleys[i].givepushback == true)
					pulleys[i].givepushtimer = $1 + 1
				else
					pulleys[i].givepushtimer = 0
				end
				if (pulleys[i].giveanglepush == nil)
					pulleys[i].giveanglepush = false
				end
				if (pulleys[i].giveangletimer == nil)
					pulleys[i].giveangletimer = 0
				end
				if (pulleys[i].giveanglepush == true)
					pulleys[i].giveangletimer = $1 + 1
				else
					pulleys[i].giveangletimer = 0
				end
				if (pulleys[i].gobackdown == true)
					pulleys[i].gobackdowntimer = $1 + 1
				else
					pulleys[i].gobackdowntimer = 0
				end
				if (pulleys[i].originalz == nil)
					pulleys[i].originalz = pulleys[i].z
				end
				if (pulleys[i].originalx == nil)
					pulleys[i].originalx = pulleys[i].x
				end
				if (pulleys[i].originaly == nil)
					pulleys[i].originaly = pulleys[i].y
				end
				if (pulleys[i].playercount == nil)
					pulleys[i].playercount = 0
				end
				if (pulleys[i].hang == nil)
					pulleys[i].hang = false
				end
				if (pulleys[i].hangtimer == nil)
					pulleys[i].hangtimer = 0
				end
				if (pulleys[i].metal == nil)
				and not (pulleys[i].spawnpoint.options & MTF_AMBUSH)
					for rover in pulleys[i].subsector.sector.ffloors()
						if ((rover.master.frontsector.floorpic == "ACZFLR14") and (rover.master.frontsector.ceilingpic == "ACZFLR14"))
							pulleys[i].metal = rover
						end
					end
				end
				if (pulleys[i].setuptimer == nil)
					pulleys[i].setuptimer = 3
				end
				if (pulleys[i].setuptimer > 0)
					pulleys[i].setuptimer = $1 - 1
				end
				if (pulleys[i].momz != 0)
					pulleys[i].setuptimer = 3
				end
				
				if (pulleys[i].setuptimer != 0)
				and not (pulleys[i].spawnpoint.options & MTF_AMBUSH)
					if (pulleys[i].momz <= 0)
						pulleys[i].metal.bottomheight = pulleys[i].z+47*FRACUNIT
					else
						pulleys[i].metal.bottomheight = pulleys[i].z+47*FRACUNIT
					end
				end
				
				for player in players.iterate
					if (pulleys[i] and pulleys[i].valid)
					and (player.mo and player.mo.valid)
					and (player.playerstate == PST_LIVE)
					and (R_PointToDist2(player.mo.x,player.mo.y,pulleys[i].x,pulleys[i].y)<= 42*FRACUNIT)
					and (abs(player.mo.z - pulleys[i].z)<= 28*FRACUNIT)
					and (player.catch == false)
					and not (player.mo.state == S_PLAY_PAIN)
					and not (player.mo.state == S_PLAY_DEAD)
					and ((player.hangobjectrecent ~= pulleys[i]) or ((player.hangobjectrecent == pulleys[i]) and (player.goingondelay == 0)))
						player.catch = true
						player.hang = true
						player.hangobject = pulleys[i]
						player.hangobjectrecent = pulleys[i]
						pulleys[i].hang = true
						pulleys[i].playercount = $1 + 1
						table.insert(pulleys[i].playerstable, player)
						if (pulleys[i].gotoangle == false)
						and (pulleys[i].goback == false)
							pulleys[i].gotoangle = true
							pulleys[i].goback = false
							pulleys[i].giveanglepush = true
						end
					end
				end
				if (pulleys[i].gotoangle == true)
				and (pulleys[i].playercount == 0)
				and (pulleys[i].z+pulleys[i].height>=pulleys[i].spawnpoint.angle*FRACUNIT-10*FRACUNIT) and (pulleys[i].z+pulleys[i].height<=pulleys[i].spawnpoint.angle*FRACUNIT+10*FRACUNIT)
				and not (pulleys[i].spawnpoint.options & MTF_AMBUSH)
					pulleys[i].goback = true
					pulleys[i].givepushtimer = 0
					pulleys[i].gotoangle = false
					pulleys[i].givepushback = true
					pulleys[i].giveanglepush = false
					pulleys[i].gobackdown = false
					pulleys[i].hang = true
				end
				if (pulleys[i].gotoangle == true)
				and (pulleys[i].playercount == 0)
				and (pulleys[i].originalx < pulleys[i].nextpoint.x)
				and (pulleys[i].x >= pulleys[i].nextpoint.x)
				and (pulleys[i].spawnpoint.options & MTF_AMBUSH)
					pulleys[i].goback = true
					pulleys[i].gotoangle = false
					pulleys[i].givepushback = true
					pulleys[i].giveanglepush = false
					pulleys[i].gobackdown = false
					pulleys[i].hang = true
				end
				if (pulleys[i].gotoangle == true)
				and (pulleys[i].playercount == 0)
				and (pulleys[i].originalx > pulleys[i].nextpoint.x)
				and (pulleys[i].x <= pulleys[i].nextpoint.x)
				and (pulleys[i].spawnpoint.options & MTF_AMBUSH)
					pulleys[i].goback = true
					pulleys[i].gotoangle = false
					pulleys[i].givepushback = true
					pulleys[i].giveanglepush = false
					pulleys[i].gobackdown = false
					pulleys[i].hang = true
				end
				if (pulleys[i].gotoangle == true)
					if (pulleys[i].playercount == 0)
					and not (pulleys[i].spawnpoint.options & MTF_AMBUSH)
					and (((pulleys[i].z+pulleys[i].height<pulleys[i].spawnpoint.angle*FRACUNIT) and (pulleys[i].z+pulleys[i].height<pulleys[i].spawnpoint.angle*FRACUNIT-10*FRACUNIT) and (pulleys[i].z+pulleys[i].height>pulleys[i].originalz) and (pulleys[i].z+pulleys[i].height>pulleys[i].originalz+10*FRACUNIT))
					or ((pulleys[i].z+pulleys[i].height>pulleys[i].spawnpoint.angle*FRACUNIT) and (pulleys[i].z+pulleys[i].height>pulleys[i].spawnpoint.angle*FRACUNIT+10*FRACUNIT) and (pulleys[i].z+pulleys[i].height<pulleys[i].originalz) and (pulleys[i].z+pulleys[i].height<pulleys[i].originalz-10*FRACUNIT)))
						pulleys[i].goback = true
						pulleys[i].gotoangle = false
						pulleys[i].givepushback = true
						pulleys[i].giveanglepush = false
						pulleys[i].gobackdown = false
						pulleys[i].momz = 0
						pulleys[i].hang = true
					end
				end
				if (pulleys[i].gotoangle == true)
					if (pulleys[i].playercount == 0)
					and (pulleys[i].spawnpoint.options & MTF_AMBUSH)
					and (((pulleys[i].z<pulleys[i].nextpoint.x) and (pulleys[i].z>pulleys[i].originalx))
					or ((pulleys[i].z>pulleys[i].nextpoint.x) and (pulleys[i].z<pulleys[i].originalx)))
						pulleys[i].goback = true
						pulleys[i].gotoangle = false
						pulleys[i].givepushback = true
						pulleys[i].giveanglepush = false
						pulleys[i].gobackdown = false
						pulleys[i].momz = 0
						pulleys[i].momx = 0
						pulleys[i].momy = 0
						pulleys[i].hang = true
						--print("go to next point WAIT NO PLAYERS")
					end
				end
				if (pulleys[i].goback == true)
				and (pulleys[i].playercount > 0)
				//and (pulleys[i].z+pulleys[i].height>=pulleys[i].originalz-10*FRACUNIT) and (pulleys[i].z+pulleys[i].height<=pulleys[i].originalz+10*FRACUNIT)
					pulleys[i].goback = false
					pulleys[i].gotoangle = true
					pulleys[i].momz = 0
					pulleys[i].momx = 0
					pulleys[i].momy = 0
					pulleys[i].giveanglepush = true
					pulleys[i].givepushback = false
					pulleys[i].gobackdown = false
					pulleys[i].hang = true
					--print("go to prev point WAIT PLAYERS ABOARD")
				end
				if (pulleys[i].gotoangle == true)
				and (pulleys[i].playercount > 0)
				and not (pulleys[i].spawnpoint.options & MTF_AMBUSH)
				and (pulleys[i].z+pulleys[i].height>=pulleys[i].spawnpoint.angle*FRACUNIT-10*FRACUNIT) and (pulleys[i].z+pulleys[i].height<=pulleys[i].spawnpoint.angle*FRACUNIT+10*FRACUNIT)
					pulleys[i].momz = 0
					pulleys[i].hang = false
				end
				if (pulleys[i].gotoangle == true)
				and (pulleys[i].playercount > 0)
				and (pulleys[i].spawnpoint.options & MTF_AMBUSH)
				and (pulleys[i].originalx > pulleys[i].nextpoint.x)
				and (pulleys[i].x <= pulleys[i].nextpoint.x)
					pulleys[i].momz = 0
					pulleys[i].momx = 0
					pulleys[i].momy = 0
					pulleys[i].hang = false
					--print("you arrived to the pullley's next point")
				end
				if (pulleys[i].gotoangle == true)
				and (pulleys[i].playercount > 0)
				and (pulleys[i].spawnpoint.options & MTF_AMBUSH)
				and (pulleys[i].originalx < pulleys[i].nextpoint.x)
				and (pulleys[i].x >= pulleys[i].nextpoint.x)
					pulleys[i].momz = 0
					pulleys[i].momx = 0
					pulleys[i].momy = 0
					pulleys[i].hang = false
					--print("you arrived to the pullley's next point")
				end
				if (pulleys[i].goback == true)
				and (pulleys[i].playercount == 0)
				and not (pulleys[i].spawnpoint.options & MTF_AMBUSH)
				and ((pulleys[i].z+pulleys[i].height>=pulleys[i].originalz-10*FRACUNIT) and (pulleys[i].z+pulleys[i].height<=pulleys[i].originalz+10*FRACUNIT))
					pulleys[i].momz = 0
					P_TeleportMove(pulleys[i], pulleys[i].x, pulleys[i].y, pulleys[i].originalz)
					pulleys[i].hang = false
				end
				if (pulleys[i].goback == true)
				and (pulleys[i].playercount == 0)
				and (pulleys[i].spawnpoint.options & MTF_AMBUSH)
				and (pulleys[i].nextpoint.x < pulleys[i].originalx)
				and (pulleys[i].x >= pulleys[i].originalx)
					pulleys[i].momz = 0
					pulleys[i].momx = 0
					pulleys[i].momy = 0
					pulleys[i].hang = false
					--print("you arrived to the pullley's prev point")
				end
				if (pulleys[i].goback == true)
				and (pulleys[i].playercount == 0)
				and (pulleys[i].spawnpoint.options & MTF_AMBUSH)
				and (pulleys[i].nextpoint.x > pulleys[i].originalx)
				and (pulleys[i].x <= pulleys[i].originalx)
					pulleys[i].momz = 0
					pulleys[i].momx = 0
					pulleys[i].momy = 0
					pulleys[i].hang = false
					--print("you arrived to the pullley's prev point")
				end
				if not (pulleys[i].spawnpoint.options & MTF_AMBUSH) 
					if (pulleys[i].goback == true)
						if (pulleys[i].givepushtimer == 1)
							if (pulleys[i].z < pulleys[i].originalz)
								pulleys[i].momz = 15*FRACUNIT
								pulleys[i].hang = true
							elseif (pulleys[i].z > pulleys[i].originalz)
								pulleys[i].momz = (-1)*15*FRACUNIT
								pulleys[i].hang = true
							end
						end
					end
				end
				if (pulleys[i].spawnpoint.options & MTF_AMBUSH)
					if (pulleys[i].goback == true)
						if (pulleys[i].givepushtimer == 1)
							if (pulleys[i].x<pulleys[i].originalx)
							and (pulleys[i].originalx>pulleys[i].nextpoint.x)
								pulleys[i].momx = 50*FRACUNIT
							end
						end
					end
				end
				if (pulleys[i].spawnpoint.options & MTF_AMBUSH)
					if (pulleys[i].goback == true)
						if (pulleys[i].givepushtimer == 1)
							if (pulleys[i].x>pulleys[i].originalx)
							and (pulleys[i].originalx<pulleys[i].nextpoint.x)
								pulleys[i].momx = (-1)*50*FRACUNIT
							end
						end
					end
				end
				if not (pulleys[i].spawnpoint.options & MTF_AMBUSH) 
					if (pulleys[i].gotoangle == true)
						if (pulleys[i].giveangletimer == 1)
							if (pulleys[i].z+pulleys[i].height<pulleys[i].spawnpoint.angle*FRACUNIT)
								pulleys[i].momz = 15*FRACUNIT
								pulleys[i].hang = true
							elseif (pulleys[i].z+pulleys[i].height>pulleys[i].spawnpoint.angle*FRACUNIT)
								pulleys[i].momz = (-1)*15*FRACUNIT
								pulleys[i].hang = true
							end
						end
					end
				end
				if (pulleys[i].spawnpoint.options & MTF_AMBUSH)
					if (pulleys[i].gotoangle == true)
						if (pulleys[i].giveangletimer == 1)
							if (pulleys[i].x<pulleys[i].nextpoint.x)
							and (pulleys[i].nextpoint.x>pulleys[i].originalx)
								pulleys[i].momx = 50*FRACUNIT
							end
						end
					end
				end
				if (pulleys[i].spawnpoint.options & MTF_AMBUSH)
					if (pulleys[i].gotoangle == true)
						if (pulleys[i].giveangletimer == 1)
							if (pulleys[i].x>pulleys[i].nextpoint.x)
							and (pulleys[i].nextpoint.x<pulleys[i].originalx)
								pulleys[i].momx = (-1)*50*FRACUNIT
							end
						end
					end
				end
				
				if (pulleys[i].hang == true)
					pulleys[i].hangtimer = $1 + 1
				else
					pulleys[i].hangtimer = 0
				end
				
				if (pulleys[i].hangtimer == 5)
					pulleys[i].hangtimer = 0
				end
			   
				if (pulleys[i].hangtimer == 1)
				and not (pulleys[i].spawnpoint.options & MTF_AMBUSH)
				and (((pulleys[i].z+pulleys[i].height<pulleys[i].spawnpoint.angle*FRACUNIT) and (pulleys[i].z+pulleys[i].height<pulleys[i].spawnpoint.angle*FRACUNIT-10*FRACUNIT) and (pulleys[i].z+pulleys[i].height>pulleys[i].originalz) and (pulleys[i].z+pulleys[i].height>pulleys[i].originalz+10*FRACUNIT))
				or ((pulleys[i].z+pulleys[i].height>pulleys[i].spawnpoint.angle*FRACUNIT) and (pulleys[i].z+pulleys[i].height>pulleys[i].spawnpoint.angle*FRACUNIT+10*FRACUNIT) and (pulleys[i].z+pulleys[i].height<pulleys[i].originalz) and (pulleys[i].z+pulleys[i].height<pulleys[i].originalz-10*FRACUNIT)))
					S_StartSound(pulleys[i],sfx_pull)
				end
				
				if (pulleys[i].hangtimer == 1)
				and (pulleys[i].spawnpoint.options & MTF_AMBUSH)
				and (((pulleys[i].x<pulleys[i].nextpoint.x) and (pulleys[i].x>pulleys[i].originalx))
				or ((pulleys[i].x>pulleys[i].nextpoint.x) and (pulleys[i].x<pulleys[i].originalx)))
					S_StartSound(pulleys[i],sfx_pull)
				end
				
				if (pulleys[i].spawnpoint.options & MTF_AMBUSH)
				and (pulleys[i].nextpoint and pulleys[i].nextpoint.valid)
				and (((pulleys[i].x<pulleys[i].nextpoint.x) and (pulleys[i].x>pulleys[i].originalx))
				or ((pulleys[i].x>pulleys[i].nextpoint.x) and (pulleys[i].x<pulleys[i].originalx)))
					local fire = P_SpawnMobj(pulleys[i].x+P_RandomRange(-10,10)*FRACUNIT,pulleys[i].y+P_RandomRange(-10,10)*FRACUNIT,pulleys[i].z+pulleys[i].height+20*FRACUNIT+P_RandomRange(-10,10)*FRACUNIT,MT_SPINDUST)
					fire.state = S_SPINFIRE1
					fire.fuse = 7
					fire.scale = pulleys[i].scale/2
				end
			end
		end
	end
end)

addHook("AbilitySpecial", function(player)
	if (mapheaderinfo[gamemap].myriadmemories)
		if player.hang == true
		and player.hangobject and player.hangobject.valid
			return true
		end
		if player.hang == true
		and player.catch == true
		and player.jumpbuttonnn == 1
			return true
		end
		if player.goingondelay > 0
			return true
		end
	end
end)

addHook("PlayerSpawn", function(player)
	if (mapheaderinfo[gamemap].myriadmemories)
		player.hang = false
		player.catch = false
		player.goingondelay = 0   //Not limiting it to the specific map because if you change level while on pulley, it could cause issues.
		player.jumpbuttonnn = 0
		player.hangobject = nil
	end
end)

addHook("MobjDamage", function(mobj, inflictor, source)
	if (mapheaderinfo[gamemap].myriadmemories)
		mobj.player.hang = false
		mobj.player.catch = false
		mobj.player.goingondelay = 10
		if (mobj.player.hangobject and mobj.player.hangobject.valid)
			mobj.player.hangobject.playercount = $1 - 1
			table.remove(mobj.player.hangobject.playerstable)
			mobj.player.hangobject = nil
		end
	end
end, MT_PLAYER)

addHook("MobjDeath", function(mobj, inflictor, source)
	if (mapheaderinfo[gamemap].myriadmemories)
		if (mobj and mobj.valid)
			mobj.player.hang = false
			mobj.player.catch = false
			mobj.player.goingondelay = 10
			if mobj.player.hangobject and mobj.player.hangobject.valid
				mobj.player.hangobject.playercount = $1 - 1
				table.remove(mobj.player.hangobject.playerstable)
				mobj.player.hangobject = nil
			end
		end
	end
end, MT_PLAYER)

addHook("MobjRemoved", function(mobj, inflictor, source)
	if (server) //Some kind of check I guess? (Can only be used in a level!)
		if (mapheaderinfo[gamemap].myriadmemories)
			if (mobj)
				mobj.player.hang = false
				mobj.player.catch = false
				mobj.player.goingondelay = 10
				if (mobj.player.hangobject)
					mobj.player.hangobject.playercount = $1 - 1
					table.remove(mobj.player.hangobject.playerstable)
					mobj.player.hangobject = nil
				end
			end
		end
	end
end, MT_PLAYER)
